<?php
/******************************************************************************/
/*    Smart Extranet  2004-2010. All right reserved. www.smart-extranet.com  */
/******************************************************************************/



function dir_space($rep){
	$racine=@opendir($rep);
	$taille=0;
	while($dossier=@readdir($racine)){
    	if(!in_array($dossier, Array("..", "."))){
    		if(is_dir("$rep/$dossier")){
    			$taille+=dir_space("$rep/$dossier");
    		}else{
    			$taille+=@filesize("$rep/$dossier");
    		}
   		}
    }
    @closedir($racine);
    return $taille;
}



#calculate the path for smarty
function calculate_smarty_path(){
	if(get_option("url_rewriting") == "0")
	{
		return "";
	}
	else
	{
		$s_path='';
		$uri=$_SERVER['REQUEST_URI'];
		
		$adresa=substr($uri, strlen($GLOBALS["SMART_HTTP_ROOT"]), strlen($uri));
		$nr_menus=count(explode('/',$adresa)) - 1;
		for($i=1;$i<$nr_menus;$i++)
		{
			$s_path.='../';
		};
		return $s_path;
	}
}

function path_encode($path){
	$path_array = explode('/', $path);
	$path_decode = "";
	$path_encode = array();
	$i = 0;
	foreach ($path_array as $value){
		$path_decode = urldecode($value);
		$path_encode[$i] = urlencode($path_decode);
		$i++;
	};
	$path_result = implode('/', $path_encode);
	return $path_result;
}

#set cookie - user, pass for an extranet
function extranet_cookie($ext_id, $user, $pass){
	$time = 2592000 + time(); 
	SetCookie ("user_cookie_".$ext_id, $user, $time);
	SetCookie ("pass_cookie_".$ext_id, $pass, $time);
}

function delete_cookie($ext_id){
	unset($_COOKIE["user_cookie_".$ext_id]);
	unset($_COOKIE["pass_cookie_".$ext_id]);
}

#replace accents
function replace_accents($str) {
	$str = htmlentities($str);
	$str = preg_replace('/&([a-zA-Z])(uml|acute|grave|circ|tilde);/','$1',$str);
	return html_entity_decode($str);
}

#underlines $search_text in $text
function search_underline($search_text, $text){
		$nr = 0;
		$l_search_text = replace_accents(strtolower($search_text));
		$search_len = strlen($l_search_text);
		$l_text = replace_accents(strtolower($text));
		$text_len = strlen($l_text);
		$pos = 0;
		$found = strpos($l_text, $l_search_text, $pos);
		$new_print_name = "";

		while ($found !== false){
			$new_print_name = $new_print_name  . substr($text, $pos, $found-$pos);
			$new_print_name = $new_print_name. '<span class="searched">' . substr($text, $found, $search_len)  . '</span>';
			$pos = $found+$search_len;
			$found = strpos($l_text, $l_search_text, $pos);
			$nr++;
		};

		$new_print_name = $new_print_name . substr($text, $pos, strlen($l_text) - $pos);

		return $new_print_name;
}

#return file type for a file name ( $file_name can be the path to that file)
function file_type($file_name){
	#file type
	$name_parts = explode('.',basename($file_name));
	if (count($name_parts)>1){
		$file_type=$name_parts[count($name_parts)-1];
	}
	else{
		$file_type='';
	};
	return $file_type;
}

#returns a file_name, without extension
function file_name($file_name_ext){
	$pos_ext = strrpos($file_name_ext, '.');
	if ($pos_ext > 0){
		$file_name = substr($file_name_ext, 0, $pos_ext);
	}
	else{
		$file_name = $file_name_ext;
	}
	return $file_name;
}

#returns id for a $dir_name with parent id $parent_id in Extranet with id $ext_id
function directory_id($dir_name, $ext_id, $parent_id){
	$query = "SELECT id FROM smart_document
						WHERE (extranet_id=" . $ext_id . ") AND (name='" . $dir_name ."') AND (is_directory='1') AND (parent_id=" . $parent_id . ")";
	$result = mysql_query($query);
	if ($row = mysql_fetch_row($result)){
		return $row[0];
	}
	else{
		return 0;
	}
}

#returns id for a $dir_name with parent id $parent_id in Extranet with id $ext_id
function document_id($file_name, $file_type, $ext_id, $parent_id){
	$query = "SELECT id FROM smart_document
				WHERE (extranet_id=" . $ext_id . ") AND (name='" . $file_name ."') AND (is_directory='0') AND (parent_id=" . $parent_id . ") AND (file_type='" . $file_type . "')";
	$result = mysql_query($query);
	if ($row = mysql_fetch_row($result)){
		return $row[0];
	}
	else{
		return 0;
	}
}

#adds to navigation array (used to show the navigation path)
function add_to_nav($name, $is_dir){
	#$nav_path array(link => name)
	if (count($GLOBALS["nav_path"])){
		$link = implode('/', $GLOBALS["nav_path"]) . "/" . $name;
		$link = path_encode($link);
	}
	else{
		$link = urlencode($name);
	};
	if ($is_dir){
		$link = $link . "/";
	};
	$GLOBALS["nav_path"][$link] = $name;
	return true;
}

#extract subdirectories & selected document, set parent, add to $nav_path 
function extract_path($array_dirs, $ext_id, $parent){
  $name = urldecode(array_shift($array_dirs));  
  if (count($array_dirs) == 1){
     	#parent
		$GLOBALS['parent_name'] = $name;
		if ($GLOBALS['parent_id'] = directory_id($name, $ext_id, $parent)){
			   add_to_nav($name, 1);		
        $name = urldecode(array_shift($array_dirs)); 
        if ($name!=''){
            $GLOBALS['doc_name'] = file_name($name);
			$GLOBALS['doc_type'] = file_type($name);
			$GLOBALS['doc_id'] = document_id($GLOBALS['doc_name'], $GLOBALS['doc_type'], $ext_id, $GLOBALS['parent_id']);
			#if file exists - set selected document
			if ($GLOBALS['doc_id']){
				add_to_nav($name, 0);
			}
			else{
			  $error =  _0200024_unknown_file;
			  return -3;
			};
         }
      }
      else{
          $error = _0200025_unknown_directory;
          return -2;
      }
  }
  else{
     if ($new_parent = directory_id($name, $ext_id, $parent)){
      add_to_nav($name, 1);
      extract_path($array_dirs, $ext_id, $new_parent);
     }
     else{
      #error -2 - 'Unknown directory!'	  
      return -2;
     }     
  }   
}

#parses path, extracts selected directory name, directories and file
function parse_path($path, $ext_id){
  $array_dirs = explode('/', $path);
  if (count($array_dirs) <= 1){    
    #error -1 - 'Unknown path!'
    return -1;
  }
  else{
    #first dir of path - selected directory - left menu	
    $GLOBALS['sel_dir_name'] = urldecode(array_shift($array_dirs));	
  	$GLOBALS['sel_dir_id'] = directory_id($GLOBALS['sel_dir_name'], $ext_id, 0);	
  	if ($GLOBALS['sel_dir_id']){
  			#set selected directory (left menu) and add directory in the navigation path
  			add_to_nav($GLOBALS['sel_dir_name'], 1);
  			if (count($array_dirs) == 1){
            	$GLOBALS['parent_name'] = $GLOBALS['sel_dir_name'];
  	        	$GLOBALS['parent_id'] = $GLOBALS['sel_dir_id'];
  	        	$name = urldecode(array_shift($array_dirs));
				if ($name!=''){
            		$GLOBALS['doc_name'] = file_name($name);
					$GLOBALS['doc_type'] = file_type($name);
					$GLOBALS['doc_id'] = document_id($GLOBALS['doc_name'], $GLOBALS['doc_type'], $ext_id, $GLOBALS['parent_id']);
					#if file exists - set selected document
					if ($GLOBALS['doc_id']){
						add_to_nav($name, 0);
					}
					else{
			  			#file not found
						return -3;
					};
         		}
    		}
   			else{
       			extract_path($array_dirs, $ext_id, $GLOBALS['sel_dir_id']);
          	}
    }
    else{
      #error -2 - 'Unknown directory!'
      return -2;
    }
    return 1;
  }
}

#returns $path for directory with $dir_id
function return_path($dir_id, &$path){
	$query = "SELECT * FROM smart_document
				WHERE (id=" . $dir_id . ") AND (is_directory='1')";
	$result = mysql_query($query);
	if ($row = mysql_fetch_array($result)){		
		//$path = urlencode($row["name"]) . '/' . $path;
		$path = $row["name"] . '/' . $path;
		if ($row["parent_id"] > 0){
			return_path($row["parent_id"], $path);
		}
		return 1;
		
	}
	else{
		$error = "Unknown file - Fichier inconnu";
		return 0;
	};
}

#returns $path for directory with $dir_id
function return_path_dec($dir_id, &$path){
	$query = "SELECT * FROM smart_document
				WHERE (id=" . $dir_id . ") AND (is_directory='1')";
	$result = mysql_query($query);
	if ($row = mysql_fetch_array($result)){		
		$path = $row["name"] . '/' . $path;
		if ($row["parent_id"] > 0){
			return_path_dec($row["parent_id"], $path);
		}
		return 1;
		
	}
	else{
		$error = "Unknown file - Fichier inconnu";
		return 0;
	};
}


 #upload a document and make thumbs if image
   function image_thumb($sourcefile, $path, $id, $file_type,$extranet_id,$before_www = false){
   		#upload file
		if($before_www == true)
		{
			# On est dans du realpath donc on vire le ../
			$WWW_SECURITY_MOD = str_replace("../","/",$GLOBALS['WWW_SECURITY']);
		}
		else
		{
			$WWW_SECURITY_MOD = $GLOBALS['WWW_SECURITY'];
		}
				if (in_array(strtolower($file_type), $GLOBALS["IMAGE_TYPES"])){
					$picsize = getimagesize("$sourcefile");
					$source_x = $picsize[0];
					$source_y = $picsize[1];
					
					#thumb
					//$new_thumb =  $path . "_assets/thumbs/thumb_".$id.".jpg";
					$new_thumb =  $path . $WWW_SECURITY_MOD."storage/". $extranet_id ."/thumbs/thumb_".$id.".jpg";
					$max_x = 100;
					$max_y = 200;
					if($source_x>$max_x)
						{
							$proportie=$source_y/$source_x;
							$dest_x=$max_x;
							$dest_y=$proportie*$max_x;
						}
					else
						{
							$dest_x = $source_x;
							$dest_y = $source_y;
						}
					if($dest_y>$max_y)
						{
							$proportie2=$dest_x/$dest_y;
							$dest_y=$max_y;
							$dest_x=$proportie2*$max_y;
						}

					$targetfile = "$new_thumb"; 
					$jpegqual = 100;
					if (strcasecmp($file_type, "jpg") == 0 OR strcasecmp($file_type, "jpeg") == 0){
						$source_id = @imagecreatefromjpeg("$sourcefile"); 
					}
					else if (strcasecmp($file_type, "gif") == 0){
						$source_id = @imagecreatefromgif("$sourcefile"); 
					}
					else if (strcasecmp($file_type, "png") == 0){
						$source_id = @imagecreatefrompng("$sourcefile"); 
					} 
					$target_id = imagecreatetruecolor($dest_x, $dest_y); 
					$target_pic = imagecopyresampled($target_id,$source_id,0,0,0,0,$dest_x,$dest_y,$source_x,$source_y); 
					imagejpeg($target_id,"$targetfile", $jpegqual);
					
					#photo
					//$new_photo=  $path . "_assets/thumbs/photo_".$id.".jpg";
					$new_photo=  $path . $WWW_SECURITY_MOD."storage/" . $extranet_id ."/thumbs/photo_".$id.".jpg";
					$max_x = 500;
					$max_y = 500;
					if($source_x>$max_x)
						{
							$proportie=$source_y/$source_x;
							$dest_x=$max_x;
							$dest_y=$proportie*$max_x;
						}
					else
						{
							$dest_x = $source_x;
							$dest_y = $source_y;
						}
					if($dest_y>$max_y)
						{
							$proportie2=$dest_x/$dest_y;
							$dest_y=$max_y;
							$dest_x=$proportie2*$max_y;
						}

					$targetfile = "$new_photo"; 
					$jpegqual = 100;
					if (strcasecmp($file_type, "jpg") == 0 OR strcasecmp($file_type, "jpeg") == 0){
						$source_id = @imagecreatefromjpeg("$sourcefile");
					}
					else if (strcasecmp($file_type, "gif") == 0){
						$source_id = @imagecreatefromgif("$sourcefile"); 
					}
					else if (strcasecmp($file_type, "png") == 0){
						$source_id = @imagecreatefrompng("$sourcefile"); 
					}
					$target_id = imagecreatetruecolor($dest_x, $dest_y);
					$target_pic = imagecopyresampled($target_id,$source_id,0,0,0,0,$dest_x,$dest_y,$source_x,$source_y); 
					imagejpeg($target_id,"$targetfile", $jpegqual);
					
					# GPS Exif
					$gps = gps_from_exif($sourcefile);
					$sql = "UPDATE smart_document SET gps = '".$gps."' WHERE id= ".$id;
					mysql_query($sql);
				}
   }

#deletes a content of a directory: 
function remove_dir_content($path){	
	$f="any non empty value";		
	$dir=opendir($path);
	#reads first entry in directory
    $f=readdir($dir); 
	
	#while $f contains name of a file or directory
    while ($f!="") 
    {
	  #if $f is directory	
      if (is_dir("$path/$f")) 
      {
	    # if $f is not this directory . or his parent ..
		if (($f!=".") && ($f!="..")) 
        {  
		   $new_path = $path . "/" . $f;
           remove_dir_content($new_path);
		   rmdir($new_path);
        }//if
      }//if		 
	  #reads line from dir $dir 
      $f=readdir($dir);
      if (!is_dir("$path/$f") && ($f != "..") && ($f != "") && ($f != "."))
      {
		unlink("$path/$f");
      }//if
    }//while
    closedir($dir);		
  }

#delete file
function delete_file($id_file,$ext_id = 0){
	if($ext_id == 0)
	{
		$ext_id = dlookup("extranet_id","smart_document","id=".$id_file);
	}
	if (file_exists($GLOBALS['WWW_SECURITY']."storage/" .$ext_id ."/" . $id_file)){
		unlink($GLOBALS['WWW_SECURITY']."storage/" .$ext_id ."/" . $id_file);
	};
	if (file_exists($GLOBALS['WWW_SECURITY']."storage/" .$ext_id ."/thumbs/thumb_".$id_file.".jpg")){
		unlink($GLOBALS['WWW_SECURITY']."storage/" .$ext_id ."/thumbs/thumb_".$id_file.".jpg");
	};
	if (file_exists($GLOBALS['WWW_SECURITY']."storage/" .$ext_id ."/thumbs/photo_".$id_file.".jpg")){
		unlink($GLOBALS['WWW_SECURITY']."storage/" .$ext_id ."/thumbs/photo_".$id_file.".jpg");
	};
	
	$query_delete_comment = "DELETE FROM smart_comment
								WHERE document_id=" . $id_file;
	mysql_query($query_delete_comment);
	
	$query_delete = "DELETE FROM smart_document
						WHERE id=" . $id_file;
	mysql_query($query_delete);
	
	$query_delete_profil = "DELETE FROM smart_document_profil
						WHERE doc_id=" . $id_file;
	mysql_query($query_delete_profil);
}

function delete_user($user_id){
	$title = dlookup("title","smart_user","id = ".$user_id);
	$first_name = dlookup("first_name","smart_user","id = ".$user_id);
	$last_name = dlookup("last_name","smart_user","id = ".$user_id);
	$company = dlookup("company","smart_user","id = ".$user_id);
	$name = $title . " " . $first_name . " " . $last_name;
	if($company != '')
		{
			$name .= " - ".$company;
		}
	$name = utf8_decode($name);
	$query_delete_user = "DELETE FROM smart_user
							WHERE id=" . $user_id;
	mysql_query($query_delete_user);
	$query_delete_access = "DELETE FROM smart_user_accesses
							WHERE user_id=" . $user_id;
	mysql_query($query_delete_access);
	
	$query_comments = "SELECT id, body FROM smart_comment WHERE user_id=" . $user_id;
	$result_comments = mysql_query($query_comments);
	while ($row_comment = mysql_fetch_array($result_comments)){		
		$result_body = $row_comment['body'];
		$query_update_comment = "UPDATE smart_comment SET body = '<span class=\"comment_ghost\">" . $name . " " . $GLOBALS['_0100494_today_deleted'] . "</span><br />" . $result_body . "' WHERE id = " .$row_comment['id'];
		//echo $query_update_comment;
		mysql_query($query_update_comment);
	}
	
}

#deletes directory and all its content in database
function remove_dir_content_db($dir_id){	
	$query = "SELECT * FROM smart_document
				WHERE parent_id=" . $dir_id;
	$result = mysql_query($query);
	while ($row = mysql_fetch_array($result)){
		if ($row["is_directory"] == '1'){
			remove_dir_content_db($row["id"]);
			$query_delete = "DELETE FROM smart_document
								WHERE id=" . $row["id"];
			mysql_query($query_delete);
			$query_delete_profil = "DELETE FROM smart_document_profil
						WHERE doc_id=" . $row["id"];
			mysql_query($query_delete_profil);
		}
		else{
			delete_file($row["id"]);
		};
	};
}

#remove directory with
function remove_dir_all($path){
		remove_dir_content($path);
		rmdir($path);
}

function delete_directory($dir_id, $ext_name){
	#remove dir from ftp incoming directory
	$dir_path = "";
	return_path($dir_id, @$dir_path);
	remove_dir_all($GLOBALS["FTP_PATH"] . '/' . substr($ext_name . '/' . $dir_path, 0, strlen($ext_name . '/' . $dir_path)-1));

	#remove subdirs, files from database
	remove_dir_content_db($dir_id);
	
	#remove 
	$query_delete = "DELETE FROM smart_document
						WHERE id=" . $dir_id;
	mysql_query($query_delete);
}

#creates directories in incoming folder with parent $dir_id
function create_dirs($dir_id, $ext_name){
	$query = "SELECT * FROM smart_document
				WHERE (parent_id=" . $dir_id . ") and (is_directory='1')";
	$result = mysql_query($query);
	while ($row = mysql_fetch_array($result)){
		 $dir_path = '';
		 return_path_dec($row["id"], @$dir_path);		 
		 $new_path = $GLOBALS["FTP_PATH"] . substr($ext_name . '/' . $dir_path, 0, strlen($ext_name . '/' . $dir_path)-1);
		 mkdir($new_path);
		 create_dirs($row["id"], $ext_name);
	}
}

#makes directory tree for extraned with $ext_id
function make_dir_tree($ext_name, $ext_id){
		$ext_path = $GLOBALS["FTP_PATH"] . $ext_name;
		if (is_dir($ext_path)){
			remove_dir_content($ext_path);
		}
		else{
			mkdir($ext_path);
		};
	
		#left menu directories
		$query_left = "SELECT id, is_directory, name 
							FROM smart_document
							WHERE (parent_id=0) AND (is_directory='1') AND (extranet_id=" . $ext_id .")
							ORDER BY publish_time";
		$result_left = mysql_query($query_left);
		$left_menu_dirs = array();
		#selected paths = array with all existing paths
		while ($row_left = mysql_fetch_array($result_left)){
			mkdir($GLOBALS["FTP_PATH"] . $ext_name . '/' . $row_left["name"]);
			create_dirs($row_left["id"], $ext_name);
		};
}

#add in array $select_paths the paths of all directories
function set_select_paths($dir_id){
	$query = "SELECT * FROM smart_document
				WHERE (parent_id=" . $dir_id . ") and (is_directory='1')";
	$result = mysql_query($query);
	while ($row = mysql_fetch_array($result)){
		 $dir_path = "";		 
		 return_path($row["id"], $dir_path);
		 $GLOBALS["select_paths"][$row["id"]] = urldecode($dir_path);
		 set_select_paths($row["id"]);
	}
	return 1;
}

#used for refresh from incoming folder
  function refresh_parse($ext_id, $parent_id,$_path_){	
		$f="any non empty value";		
		$dir=opendir(".");		
	    $f=readdir($dir); #citeste prima linie(primul nume de fisier-director)
		
	    while ($f!="") #cat timp $f contine numele unui director sau fisier
	    {
	      if (is_dir($f)) #daca $f e director
	      {
			if (($f!=".") && ($f!="..")) #f nu este directorul actual . sau parintele lui ..
	        {  
			  $query = "SELECT id FROM smart_document
			  				WHERE (parent_id=" . $parent_id . ") AND (is_directory='1') AND (name='" . $f . "')";
	          $result = mysql_query($query);
			  if ($row = mysql_fetch_array($result)){
			  	chdir($f); #intra in directorul $f
	          	refresh_parse($ext_id, $row["id"]); #recursiv
			  	chdir("../");
			 }
	        }//if
	      }//if		  
	      
	      if (!is_dir($f) && ($f != "..") && ($f != "") && ($f != "."))
	      {
		  	$file_name = file_name($f);
			$file_type = file_type($f);
			$file_size = round(filesize($f)/1024);
			
  			$query = "INSERT INTO smart_document 
						SET 
						extranet_id=" . $ext_id . ",
						parent_id='" . $parent_id . "',
						is_directory='0',
						file_type='" . $file_type . "',
						file_size='" . $file_size . "',
						uploaded_by='" . $GLOBALS["PRODUCT_NAME"] . "',
						uploaded_id_by=0,
						name='" . $file_name . "',
						type='file',
						publish_time='" . date("Y-m-d H:i") ."',
						unik = '".code_unik("document",10)."'";
						
			if(mysql_query($query)){
				$mysql_insert_id = mysql_insert_id();
				//REGLE GENERAL : BEFORE_WWW (true ou false) et refresh = REALPATH en general
				//Attention lorsque l'on utilise WWW_SECURITY et qu'il contient un ../ ... il faut le modifier dans image_thumb()
				if($GLOBALS['BEFORE_WWW'] == true)
				{
					/* /!\ Attention, le chemin en cours n'est pas forcement le chemin racine de l'appli
					         Donc $path recupere le chemin racine de l'appli. Si appli dans un dossier, a fonctionne
						pour le new_path, on a besoin de sortir ../ afin de deplacer d'incoming vers storage
						image_thumb($f, $path, mysql_insert_id(), $file_type,$ext_id,true);
						Le true permet de dire que l'on est avant le repeteroire racine appli pour le stockage <=> $GLOBALS['BEFORE_WWW'] == true
						Cela permettra lors de la creation des miniatures de faire sauter le fameux ../ 
					*/
					$path = $GLOBALS["www_path"];
					if($_path_ != "")
					{
						$dir_parent = $path;
						$dir_parent = strrev($dir_parent);
						$dir_parent = substr($dir_parent,strpos($dir_parent,"/")+1);
						$path = strrev($dir_parent);
					}
					image_thumb($f, $path, $mysql_insert_id, $file_type,$ext_id,true);
					$new_path = str_replace("..","",$GLOBALS["WWW_SECURITY"]);
					rename(realpath($f), $path . $new_path . 'storage/' . $ext_id . '/' . $mysql_insert_id);
				}
				else
				{
					/* /!\ Oblig ici de faire des modifs de variables afin d'obtenir le chemin exact realpath des dossies de stockage
					*/
					$path = str_replace(substr(realpath($f),strpos(realpath($f),"_assets")),"",realpath($f));
					image_thumb($f, $path, $mysql_insert_id, $file_type,$ext_id);
					$new_path = str_replace(substr(realpath($f),strpos(realpath($f),"incoming")),"storage",realpath($f));
					rename(realpath($f), $new_path.'/' . $ext_id . '/' . $mysql_insert_id);
				}
			};
	      }//if
		  $f=readdir($dir);#citeste linie din $dir
	    }//while
	    closedir($dir);
   }
   
   #used for refresh from incoming folder
  function search_files($ext_id, $parent_id){
 
		$f="any non empty value";		
		$dir=opendir(".");		
	    $f=readdir($dir); #citeste prima linie(primul nume de fisier-director)
		if (filesize($f) == 0)
		  {
			unlink($f);
		  }
		  else
		  {
		      if (!is_dir($f) && ($f != "..") && ($f != "") && ($f != "."))
		      {
			  	$GLOBALS["incoming_files"]++;
		      }//if
		  }
	    while ($f!="") #cat timp $f contine numele unui director sau fisier
	    {
	      if (is_dir($f)) #daca $f e director
	      {
			if (($f!=".") && ($f!="..")) #f nu este directorul actual . sau parintele lui ..
	        {
			  $query = "SELECT id FROM smart_document
			  				WHERE (parent_id=" . $parent_id . ") AND (is_directory='1') AND (name='" . $f . "')";
	          $result = mysql_query($query);
			    if ($row = mysql_fetch_array($result)){
			  	chdir($f); #intra in directorul $f
	          	search_files($ext_id, $row["id"]); #recursiv
			  	chdir("../");
			 };
	        }//if
	      }//if
	      $f=readdir($dir);#citeste linie din $dir
		  if (filesize($f) == 0)
		  {
			@unlink($f);
		  }
		  else
		  {
		      if (!is_dir($f) && ($f != "..") && ($f != "") && ($f != "."))
		      {
			  	$GLOBALS["incoming_files"]++;
		      }//if
		  }
	    }//while
	    closedir($dir);
   }
   
   #checks if refresh is needed - if a file exists in incoming folder
   function refresh_needed($ext_id, $ext_name,$_path_ = "")
   {   
		$dir_parent =  getcwd();

		$dir_parent = strrev($dir_parent);
		#Gestion du cas site mobile
		$dir_enplus = "";
		if($_path_ != "")
		{
			$dir_enplus = substr($dir_parent,strpos($dir_parent,"/")+1);
			$dir_enplus = substr($dir_enplus,0,strpos($dir_enplus,"/"));
			$dir_enplus = strrev($dir_enplus)."/";

		}
		#Fin
		$dir_parent = substr($dir_parent,0,strpos($dir_parent,"/"));
		$dir_parent = $dir_enplus.strrev($dir_parent);
		$dir_parent;

		if (is_dir($_path_.$GLOBALS["WWW_SECURITY"]."incoming"))
		{
		
	   		if (!@chdir($_path_.$GLOBALS["WWW_SECURITY"]."incoming/" . $ext_name))
			{
				mkdir($_path_.$GLOBALS["WWW_SECURITY"]."incoming/" . $ext_name);
				chdir($_path_.$GLOBALS["WWW_SECURITY"]."incoming/" . $ext_name);
			};
			$query = "SELECT * FROM smart_document
						WHERE extranet_id=" . $ext_id . " AND is_directory='1' AND parent_id=0";
			$result = mysql_query($query);
			$row = mysql_fetch_array($result);
			if (($row["name"]) && (!@chdir($row["name"]))){
				mkdir($row["name"]);
				chdir($row["name"]);
			};
			while ($row){

				search_files($ext_id, $row["id"]);
				$row = mysql_fetch_array($result);
				if ($row){
					$change_dir = @chdir('../' . $row["name"]);
					if (!$change_dir){
						mkdir('../' . $row["name"]);
						chdir('../' . $row["name"]);
					}
				}
			};
			if($_path_.$GLOBALS['BEFORE_WWW'] == false)
			{
				//echo getcwd()."<br />";
				chdir("../../../../../");
			}
			else
			{
				$x = substr_count($GLOBALS['WWW_SECURITY'], '/') - 1;
				$dep = "../../../";
				$goto = str_pad($dep, (9+($x*3)) , "../").$dir_parent; 
				chdir($goto);
			}
		}
   }

   #moves files from incoming in storage folder and inserts them in smart_document
   function refresh($ext_id, $ext_name,$_path_ = ""){
 		$dir_parent =  getcwd();
		$dir_parent = strrev($dir_parent);
		#Gestion du cas site mobile
		$dir_enplus = "";
		if($_path_ != "")
		{
			$dir_enplus = substr($dir_parent,strpos($dir_parent,"/")+1);
			$dir_enplus = substr($dir_enplus,0,strpos($dir_enplus,"/"));
			$dir_enplus = strrev($dir_enplus)."/";

		}
		#Fin
		$dir_parent = substr($dir_parent,0,strpos($dir_parent,"/"));
		$dir_parent = $dir_enplus.strrev($dir_parent);
		$dir_parent;
   		if (!@chdir($_path_.$GLOBALS["WWW_SECURITY"]."incoming/" . $ext_name)){
			mkdir($_path_.$GLOBALS["WWW_SECURITY"]."incoming/" . $ext_name);
			chdir($_path_.$GLOBALS["WWW_SECURITY"]."incoming/" . $ext_name);
		};
		$query = "SELECT * FROM smart_document
					WHERE extranet_id=" . $ext_id . " AND is_directory='1' AND parent_id=0";
		$result = mysql_query($query);
		$row = mysql_fetch_array($result);
		if (($row["name"]) && (!@chdir($row["name"]))){
			mkdir($row["name"]);
			chdir($row["name"]);
		};
		while ($row){
			refresh_parse($ext_id, $row["id"],$_path_);
			$row = mysql_fetch_array($result);
			if ($row){
				$change_dir = @chdir('../' . $row["name"]);
				if (!$change_dir){
					mkdir('../' . $row["name"]);
					chdir('../' . $row["name"]);
				}
			}
		};
		if($GLOBALS['BEFORE_WWW'] == false)
		{
			chdir("../../../../../");
		}
		else
		{
			$x = substr_count($GLOBALS['WWW_SECURITY'], '/') - 1;
			$dep = "../../../";
			$goto = str_pad($dep, (9+($x*3)) , "../").$dir_parent; 
			chdir($goto);
		}
   }

   #returns array with media files
   function media_files(){
   		$array_media = array();
		$array_file_types = array("jpg", "gif", "png", "swf", "JPG", "GIF", "PNG", "SWF");
   		$f="any non empty value";		
		$dir=opendir("_assets/media_files");		
	    $f=readdir($dir); #citeste prima linie(primul nume de fisier-director)
	    while ($f!="") #cat timp $f contine numele unui director sau fisier
	    {
	        if (!is_dir($f) && ($f != "..") && ($f != "") && ($f != ".")){
				if (($f!=".") && ($f!="..") && in_array(file_type($f), $array_file_types)) #f nu este directorul actual . sau parintele lui ..
		        {  
				  array_push($array_media, $f);
				}
	        }//if  
	      $f=readdir($dir);#citeste linie din $dir
		 }
		closedir($dir);
		
		return $array_media;
   }

   #returns array with banner files
   function extranet_banners(){
   		$array_banners = array();
		$array_file_types = array("jpg", "gif", "png", "JPG", "GIF", "PNG");
   		$f="any non empty value";		
		$dir=opendir("_assets/banners");		
	    $f=readdir($dir); #citeste prima linie(primul nume de fisier-director)
	    while ($f!="") #cat timp $f contine numele unui director sau fisier
	    {
	        if (!is_dir($f) && ($f != "..") && ($f != "") && ($f != ".")){
				if (($f!=".") && ($f!="..") && in_array(file_type($f), $array_file_types)) #f nu este directorul actual . sau parintele lui ..
		        {
				  array_push($array_banners, $f);
				}
	        }//if
	      $f=readdir($dir);#citeste linie din $dir
		 }
		closedir($dir);
		
		return $array_banners;
   }
   
   #delete comment
   
   function delete_comment($id_comment){
   		$query_delete = "DELETE FROM smart_comment
							WHERE id=" . $id_comment;
		mysql_query($query_delete);
		return 1;
   }

	function zonedate($layout, $countryzone, $daylightsaving, $add_time = 0)
	{
		if ($daylightsaving){
		$daylight_saving = date('I');
		if ($daylight_saving){$zone=3600*($countryzone+1);}
		}
		else {
		if ($countryzone>>0){$zone=3600*$countryzone;}
		else {$zone=0;}
		}
		$date=gmdate($layout, time() + $zone + $add_time);
		return $date;
	}
	
	function right_for_thumb($doc_id,$ext_id)
	{
		$query_right = "SELECT COUNT(*) FROM smart_document LEFT JOIN smart_document_profil ON smart_document.id = smart_document_profil.doc_id
							WHERE id=" . $doc_id . " AND extranet_id=" . $ext_id . " AND (direction_only='0' OR (direction_only='1' AND profil_id = ".$_SESSION['profil']."))
							AND is_directory ='0'";
		$result_right = mysql_query($query_right);
		$right = mysql_fetch_row($result_right);

		if ($right[0] > 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
  	  function removeaccents($string)  	  {   	   
	  $string= strtr($string,"", 
	 "aaaaaaaaaaaaooooooooooooeeeeeeeecciiiiiiiiuuuuuuuuynn");  
	 $string = str_replace("&amp;","&",$string);
	   return $string;  
	  }	
	
	# give the url search for a tag
	function check_tags($tags)
	{
		if (strlen($tags) > 0 )
		{
			$tag = explode(" ", $tags);
			$ret = "";
			foreach ($tag as $word)
			{
				$url = giveurl($GLOBALS['ext_name_enc'],'index',"search_submit=1&search_tags=".$word);
				$ret = $ret.'<a href="'.$url.'">'.$word.'</a> ';
				//$ret = $ret.'<a href="?search_submit=1&search_tags='.$word.'">'.$word.'</a> ';
				//$ret = $ret.'<a href=""> </a>';
			}
			return $ret;
		}
		else
		{
			return "";
		}
	}

	#give the url search for a tag with a search underline
	function check_tags_and_search_underline($search_text,$tags,$search_by_tags)
	{
		$nr = 0;
		$l_search_text = replace_accents(strtolower($search_text));
		$search_len = strlen($l_search_text);
		$l_text = replace_accents(strtolower($tags));
		$text_len = strlen($l_text);
		$pos = 0;
		$found = strpos($l_text, $l_search_text, $pos);
		$new_print_name = "";

		while ($found !== false){
			$new_print_name = $new_print_name  . substr($tags, $pos, $found-$pos);
			if (substr($tags, $pos+$search_len, 1) != " ")
			{
				$new_print_name = $new_print_name. '[s]' . substr($tags, $found, $search_len)  . '[/s]';
			}
			else
			{
				$new_print_name = $new_print_name. ' [s] ' . substr($tags, $found, $search_len)  . ' [/s] ';
			}
			$pos = $found+$search_len;
			$found = strpos($l_text, $l_search_text, $pos);
			$nr++;
		};
		$new_print_name = $new_print_name . substr($tags, $pos, strlen($l_text) - $pos);
		$tags = $new_print_name;
	//return $tags;
	
		if (strlen($tags) > 0 )
		{
			$tag = explode(" ", trim($tags));
			$ret = "";
			foreach ($tag as $word)
			{
				
				if (($word != '[s]') AND ($word != '[/s]'))
				{
					if ($search_by_tags AND ($word == $search_text))
					{
						$ret = $ret.$word." ";
					}
					else
					{
						$word_url = str_replace("[s]",'',$word);
						$word_url = str_replace("[/s]",'',$word_url);
						$word_url = str_replace(" ",'',$word_url);
						$url = giveurl($GLOBALS['ext_name_enc'],'index',"search_submit=1&search_tags=".$word_url);
						$ret = $ret.'<a href="'.$url.'">'.$word.'</a> ';
						//$ret = $ret.'<a href="?search_submit=1&search_tags='.$word_url.'">'.$word.'</a> ';
					}
				}
				else
				{
					$ret = $ret.$word;
				}
			}
			$ret = str_replace("[s]",'<span class="searched">',$ret);
			$ret = str_replace(" [/s]",'</span> ',$ret);
			$ret = str_replace("[/s]",'</span>',$ret);
			return $ret;
		}
		else
		{
			return "";
		}		
		
	}
	
	#function for replace : , ; by blank in tags
	function parse_tags($tags) {
		$tags = str_replace(";"," ",$tags);
		$tags = str_replace(":"," ",$tags);
		$tags = str_replace(","," ",$tags);
		return $tags;
	}

	# return IP adress of user
	function get_ip(){
		if(isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
		  $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		}
		elseif(isset($_SERVER['HTTP_CLIENT_IP'])) {
		  $ip  = $_SERVER['HTTP_CLIENT_IP'];
		}
		else {
		  $ip = $_SERVER['REMOTE_ADDR'];
		}
		return $ip;
	}	
	
	#main function for record log
	function log_action($extranet_id, $user_id, $user_name,$action,$param_id,$param_name,$parent)
	{
		$log_time = time();
		$log_ip = get_ip();
		$query = "INSERT INTO smart_log
				(time,ip,extranet_id,user_id,user_name,action,param_id,param_name,parent) 
				VALUES ('".$log_time."',
						'".$log_ip."',
						".$extranet_id.",
						".$user_id.",
						'".$user_name."',
						'".$action."',
						".$param_id.",
						'".$param_name."',
						".$parent.")";
		mysql_query($query);
		//echo $query;
		return mysql_insert_id();
	}
	
	#record login log
	function log_connexion($user_id,$user_name,$action)
	{
		$extranet_id = $GLOBALS["ext_id"];

		if ($action == "LOGIN_FAILED")
		{
			$query = "SELECT count(param_id) FROM smart_log WHERE action = 'login_failed' AND user_name = '".$user_name."' AND (time + 1800) > ".time();
			$result_param = mysql_query($query);
			$param = mysql_fetch_row($result_param);
			$param_id = 1;
			$param_name = "nb login failed";

			if ($param[0])
			{
				$param_id = $param[0] + 1;
			}
			log_action($extranet_id,$user_id,$user_name,$action,$param_id,$param_name,0);	
			return $param_id;
		}
		else
		{
			$param_id = "null";
			$param_name = "null";
			return log_action($extranet_id,$user_id,$user_name,$action,$param_id,$param_name,0);	
		}
	}
	
	#return time of the third login failed
	function get_last_login_failed($user_name)
	{
		$query = "SELECT time FROM smart_log WHERE action = 'login_failed' AND user_name = '".$user_name."' AND param_id = 3 AND (time + 1800) > ".time();
		$result_param = mysql_query($query);
		$param = mysql_fetch_row($result_param);
		if ($param[0])
		{
			return $param[0];
		}
		else
		{
			return 0;
		}
	}
	
	#record doc information
	function log_doc_information($action,$param_id,$param_name)
	{
		$extranet_id = $GLOBALS["ext_id"];
		$user_id = $_SESSION["user_id"];
		$user_name = $_SESSION["user_name"];
		$parent = $_SESSION["log_session"];
		return log_action($extranet_id,$user_id,$user_name,$action,$param_id,$param_name,$parent);
	}

	#for sort a array
	function arrayColumnSort()
	{
		$n = func_num_args();
		$ar = func_get_arg($n-1);
		if(!is_array($ar))
		 return false;

		for($i = 0; $i < $n-1; $i++)
		 $col[$i] = func_get_arg($i);

		foreach($ar as $key => $val)
		 foreach($col as $kkey => $vval)
		   if(is_string($vval))
			 ${"subar$kkey"}[$key] = $val[$vval];

		$arv = array();
		foreach($col as $key => $val)
		 $arv[] = (is_string($val) ? ${"subar$key"} : $val);
		$arv[] = $ar;

		call_user_func_array("array_multisort", $arv);
		return $ar;
	}

	#Function dlookup for easy
	function dlookup($champ,$table,$criteres)
	{
		$requete = "SELECT ".$champ." FROM ".$table;
		if (strlen($criteres) > 0)
			{
				$requete .= " WHERE ".$criteres;
			}
			//echo $requete;
		$res_dlookup = mysql_query($requete);
		if ($res_dlookup !== false)
		{
			$row_dlookup = mysql_fetch_row($res_dlookup);
			return $row_dlookup[0];
		}
		else
		{
			return "";
		}
	}
	
	function dump_db($name)
	{
		$dir = $GLOBALS['WWW_SECURITY']."db_backup/";
		$dir_res = opendir($dir);
		$i = 0;

		$file_to_delete = "";
		$atime = "2000000000";	
		while ($content = readdir($dir_res)) 
		{
				if ($content != "." && $content != ".." && !is_dir($content)) 
				{
					if(is_file($GLOBALS['WWW_SECURITY']."db_backup/".$content))
					{
						$f_time =  filemtime($GLOBALS['WWW_SECURITY']."db_backup/".$content);
						if ($f_time < $atime)
						{
							$file_to_delete = $content;
							$atime = $f_time;
						}
						$i++;
					}
				}
		}

		if($i > 0)
		{
			unlink($GLOBALS['WWW_SECURITY']."db_backup/".$file_to_delete);
		} 		
	
	
		$date = date("d-m-Y"); // On dfinit le variable $date ( ici son format )
		$host = $GLOBALS['DB_HOST'];
		$user = $GLOBALS['DB_LOGIN'];
		$pass = $GLOBALS['DB_PASSWD'];
		$db = $GLOBALS['DB_NAME'];
		//$backup = $db."bdd-backup_".$date.".sql.gz";
		$backup = $name;
		// Utilise les fonctions systme : MySQLdump & GZIP pour gnrer un backup gzip
		$command = "mysqldump -h$host -u$user -p$pass $db > ".$GLOBALS['WWW_SECURITY']."db_backup/$backup";
		
		
		sleep(7);  
			 


	
		
		return system($command);
		// Dmarre la procdure de tlchargement
		/*
		$taille = filesize($backup);
		header("Pragma: public");
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Cache-Control: public");
		header("Content-Description: File Transfer");
		header("Content-Type: application/gzip");
		header("Content-Disposition: attachment; filename=$backup;");
		header("Content-Transfer-Encoding: binary");
		header("Content-Length: ".$taille);
		@readfile($backup);*/
		// Supprime le fichier temporaire du serveur
		//unlink($backup);
	}
	
	function send_email($template,$to,$from_email,$from_name,$reciept,$tags,$pj ="")
	{
		$boundary='didondinaditondelosdudosdodudundodudindon';
		$headers = "MIME-Version: 1.0\n";
		if($pj != "")
		{
			$headers .= "Content-Type: multipart/mixed; boundary=\"".$boundary."\"\n";;
		}
		else
		{
			$headers .= "Content-type: text/html; charset=iso-8859-1\n";
		}
		$headers .= "X-Priority: 3\n";
		if ($reciept){
			$headers .= "Disposition-Notification-To: " . $from_name . "<" . $from_email . ">";
		};
		$headers .= "X-Mailer: php\n";
		$headers .= "X-Sender: <".$from_email.">\n"; 
		$headers .= "From: \"".removeaccents($from_name)."\" <".$from_email.">\n";
		$headers .= "Return-Path: <".$from_email.">\n"; 
		
		$file_template=fopen($GLOBALS['path_mobile']."_assets/email_templates/".$GLOBALS['LANGUAGE_ID']."/".$template.".txt","r");
		$body_email = "";
		$subject = false;
		$body = false;

		while(!feof($file_template)){
			$line = trim(fgets($file_template,4096));

			foreach ($tags as $key => $value) {
				$line = str_replace('[+'.$key.'+]', $value, $line);
			}

			if (strpos($line,"[/SUBJECT]") !== false) {
			//echo ">FIN SUJET<br />";
				$subject = false;
			}
			if (strpos($line,"[/BODY]") !== false) {
			//echo ">FIN BODY<br />";
				$body = false;
			}
			if ($subject == true) {
			//echo ">LECTURE SUJET<br />";
				$subject_email = $line;
			}
			if ($body == true) {
			//echo ">LECTURE BODY<br />";
				$body_email .= $line . '<br />';
			}
			//echo ">LIGNE $line<br />";
			if (strpos($line,"[SUBJECT]") !== false) {
			//echo ">AMORCE SUJET<br />";
				$subject = true;
			}
			if (strpos($line,"[BODY]") !== false) {
			//echo ">AMORCE BODY<br />";
				$body = true;
			}
		}
		fclose($file_template);
		if (($GLOBALS['L_U'] == 4) AND (substr($template,0,5) != "trial"))
		{
			$body_email .= $GLOBALS['_0100686_email_pub_l1'] . '<br />';
			$body_email .= $GLOBALS['_0100687_email_pub_l2'] . '<br />';
			$body_email .= $GLOBALS['_0100688_email_pub_l3'] . '<br />';
			$body_email .= $GLOBALS['_0100689_email_pub_l4'] . '<br />';
			$body_email .= $GLOBALS['_0100690_email_pub_l5'] . '<br />';
		}
		$body_email = '<html>'.$body_email.'</html>';

		if($pj != "")
		{
			$body_email = "--". $boundary ."\nContent-Type: text/html; charset=ISO-8859-1\r\n\n".$body_email."\n\n"."--" .$boundary."\n".$pj;
		}
		
		$i = 0;
		foreach ($to as $to_array){
			if (mail($to_array, $subject_email, $body_email, $headers)) {
				$i++;
			}
		}
		if ($i > 0) {
			return true;
		}
		else
		{
			return false;
		}
	}
	
 function get_infile ($fileName , $key , $separator = '=' , $commentchar = '//' )
 {
	 $i=0;
	 $buffer = array();
	 if ( file_exists ($fileName) ) {
	 $p = fopen ($fileName , 'r' ) ;
	 if($p) {
	 //file in memory
	 while ( !feof ($p) ) {
		 $buffer[$i] = fgets ($p) ;
		 $i++;
		 }
		 fclose($p);
		 }
		 $bufferlength = count ( $buffer );
		 for( $a=0 ; $a < $bufferlength ; $a++ ) {
			 $var = explode( $separator , $buffer[$a] );

			 if ( count ($var) > 1 )
			 if ( $var[0][0] != $commentchar )//line comment
			 if( trim($var[0]) == $key ){
			 $var = explode ( $commentchar , $var[1] ); 
			 $var[0] = rtrim ( $var[0] , "\x00..\x1F" );
			 return $var[0];//good key
			 }
		 }
	 }
	 return NULL;
 }

function set_infile($fileName , $inikey , $inival , $fin, $separator = '=' , $commentchar = '//' )
{
	$update = false ;
	$var = array();
	if ( get_infile ( $fileName , $inikey , $separator , $commentchar ) )
	{
		$update = true ;
	}
	$i = 0;

	if ( !$update ) 
	{
		if ( file_exists ($fileName) )
		{
			$p = fopen ( $fileName , 'a' );
		}
		else  
		{
			$p = fopen ( $fileName , 'w' ); //file create
		}
		if ($p) 
		{
		fwrite ( $p , $inikey.$separator.$inival."\r\n" );
		fclose ( $p );
		}
	}
	else 
	{

		if ( file_exists ($fileName) ) 
		{

			$p = fopen ( $fileName , 'r' ) ;
			if($p) 
			{

				while ( !feof ( $p ) ) 
				{

						 $buffer[$i] = fgets ( $p );
						 $buffer[$i] = rtrim ( $buffer[$i] , "\x00..\x1F" );

						 $var = explode ( $separator , $buffer[$i] ) ;

						if ( count ( $var ) > 1 )
						{
							if ( $var[0][0] != $commentchar )
							{

								if ( trim($var[0]) == $inikey ) 
								{

									if ( isset ( $var[1] ) )
									{
										$var = explode ( ";" ,$var[1]);

									}
									if ( isset ( $var[0] ) )
									{
										if ( $var[0] != '' )
										{
											$var[0]=ltrim($var[0],"\x00");
											$buffer[$i] = $inikey.$separator.$inival.$fin;
											//.."\t".$commentchar.$var[0];

										}
									}
									else
									{
										$buffer[$i] = $inikey.$separator.$inival;
									}
								}
							}
							
						}
					$i++;
				}
				fclose( $p );
			}
			unlink($fileName);
			$p = fopen ( $fileName , 'w' ) ;
			$i = 0;

			if ($p) 
			{
				$bufferlength = count ( $buffer );
				$stop = "\n";
				while ( $i < $bufferlength ) 
				{
						if (($i+1) == $bufferlength)
							{ $stop = ""; }
						fwrite ( $p , $buffer[$i].$stop );

					$i++;
				}

				fclose ($p);
			}
		}
	}
 }	

	function validate_email($email)
	{
		if( !ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.
				  '@'.'[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.
				  '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.
				  '[-!#$%&\'*+/0-9=?A-Z^_`a-z{|}~]$', $email) )
		{
			return false;
		}
		
		return true;
	}
	
	function get_version($option = 0) {
		return get_option("version");		
	}
	
	function test_dir($dir)
	{
		$ok = true;
		if($dir == 0)
		{
			$query = "SELECT id FROM smart_extranet";
			$result = mysql_query($query);
			
			while ($row = mysql_fetch_array($result))
			{
				if(!is_dir($GLOBALS['WWW_SECURITY']."storage/".$row['id']))
				{
					$ok = false;	
				}	
			}
		}
		else
		{
				if(!is_dir($GLOBALS['WWW_SECURITY']."storage/".$dir))
				{
					$ok = false;	
				}				
		}
		
		return $ok;
		
	}
	
	function compare_access($id_of_limited_admin,$id_of_user)
	{
		$delete_auth = true;
		#List of access user
		$query = "SELECT smart_extranet.id FROM smart_extranet";
		$result = mysql_query($query);
		while ($row_access = mysql_fetch_array($result)){
			$nb_la = dlookup("count(*)","smart_user_accesses","extranet_id = ".$row_access['id']." AND user_id = ".$id_of_limited_admin);
			$nb_u = dlookup("count(*)","smart_user_accesses","extranet_id = ".$row_access['id']." AND user_id = ".$id_of_user);
			if($nb_u > $nb_la) 
			{
				$delete_auth = false;
			}
		}	
		return $delete_auth;
	
	}
	
	function zip_archive()
	{
		$complete = true;
		dump_db("dump_".$GLOBALS['DB_NAME']."_".date('d_m_Y_H_i').".sql");
		sleep(4); 
		/*$js = date("w");
		if ($js == 0)
		{
			$js = 7;
		}
		*/
		$name_config = str_replace("https://","",$GLOBALS['SITE_ROOT']);
		$name_config = str_replace("http://","",$name_config);
		$name_config = str_replace(".","_",$name_config);
		$name_config = str_replace("/","_",$name_config);
		$name = "config_".$name_config."_".date("d").date("m").date("Y")."_".date("H").date("i").".zip";
		$archive = new PclZip($GLOBALS['WWW_SECURITY'].'config_backup/'.$name);
		  $v_list = $archive->add($GLOBALS['WWW_SECURITY'].'db_backup/,../www/_assets/,../www/_config/config.inc.php,../www/_config/obconfig.inc.php,../www/_config/trialconfig.inc.php',PCLZIP_OPT_REMOVE_PATH, "..");
		  //$v_list = $archive->add('../www/_images/',PCLZIP_OPT_REMOVE_PATH, "..");
		  if ($v_list == 0) {
		    $complete = false;
		  }

		  
		$headers = "MIME-Version: 1.0\n";
		$headers .= "Content-type: text/html; charset=iso-8859-1\n";
		$headers .= "X-Priority: 3\n";
		$headers .= "X-Mailer: php\n";
		$headers .= "X-Sender: <".$GLOBALS['MAINTAIN_EMAIL'].">\n"; 
		$headers .= "From: \"".$GLOBALS['PRODUCT_NAME']."\" <".$GLOBALS['MAINTAIN_EMAIL'].">\n";
		$headers .= "Return-Path: <".$GLOBALS['MAINTAIN_EMAIL'].">\n"; 		  
		  
		if ($complete == true)
		{
			sleep(4);  
			 
			$dir = $GLOBALS['WWW_SECURITY']."config_backup/";
			$dir_res = opendir($dir);
			$zip = array();
			$i = 0;

			$file_to_delete = "";
			$atime = "2000000000";

			while ($content = readdir($dir_res)) 
			{
					if ($content != "." && $content != ".." && !is_dir($content)) 
					{
						if(is_file($GLOBALS['WWW_SECURITY']."config_backup/".$content))
						{
							$f_time =  filemtime($GLOBALS['WWW_SECURITY']."config_backup/".$content);
							if ($f_time < $atime)
							{
								$file_to_delete = $content;
								$atime = $f_time;
							}
							$i++;
						}
					}
			}

			if($i > 1)
			{
				unlink($GLOBALS['WWW_SECURITY']."config_backup/".$file_to_delete);
			} 
			$body = date('d/m/Y H\h i\m\i\n s\s', time())."<br />";
			$body .= $GLOBALS['_0100507_back_ok'] . " ". $GLOBALS['SITE_ROOT']."<br />";
			$body .= $GLOBALS['_0100514_ok_backupmail'] ."<br />";
			$body .= $name ." : ".round(filesize($GLOBALS['WWW_SECURITY']."config_backup/".$name)/1024)." ko";

			mail($GLOBALS['MAINTAIN_EMAIL'], $GLOBALS['_0100507_back_ok'] . " ". $GLOBALS['SITE_ROOT']." - ". $GLOBALS['_0100672_title_cfg_mail'], $body,$headers);

		}
		else
		{
			$body = date('d/m/Y H\h i\m\i\n s\s', time())."<br />";
			$body .= $GLOBALS['_0100505_bck_pb'] . " ". $GLOBALS['SITE_ROOT']."<br />";
			$body .= $GLOBALS['_0100464_sn'] . " ". $GLOBALS['SERIAL_NUMBER']."<br />";
			$body .= $GLOBALS['_0100506_check'] ."<br />";

			mail($GLOBALS['MAINTAIN_EMAIL'], $GLOBALS['_0100505_bck_pb'] . " ". $GLOBALS['SITE_ROOT'], $body,$headers);
		}
		return $complete;
	}
 
	function give_my_favorite_extranet ($id) {
		#extranet list
		if ($_SESSION['rights'] == 'super_admin') {
			$query_extranet = "SELECT id, status FROM smart_extranet WHERE def= '1' ORDER BY name";
		}
		else
		{
			$query_extranet = "SELECT id, status FROM smart_extranet INNER JOIN smart_user_accesses ON smart_extranet.id = smart_user_accesses.extranet_id WHERE user_id = ".$id." ORDER BY status, name";
		}
		$result_extranet = mysql_query($query_extranet);
		$i = 0;
		while ($row_extranet = mysql_fetch_array($result_extranet)){
			$results_extranet[$i] = $row_extranet['id'];
			$ext = $row_extranet['id'];
			$status_extranet[$ext] = $row_extranet['status'];
			$i++;
		}
		
		#Acces doc list
		$query_docs = "SELECT count(id) as nb, extranet_id from smart_log WHERE user_id = ".$id." AND action = 'doc_see' GROUP BY extranet_id ORDER BY nb DESC, extranet_id asc";
		$result_docs = mysql_query($query_docs);
		$i = 0;
		$best_nb = 0;
		$favorite = 0;
		while ($row_docs = mysql_fetch_array($result_docs)){

			if ($row_docs['nb'] > $best_nb && in_array($row_docs['extranet_id'], $results_extranet))
			{
				
				$ext = $row_docs['extranet_id'];

				if($status_extranet[$ext] == 'open')
				{
					$favorite = $row_docs['extranet_id'];
					$best_nb = $row_docs['nb'];
				}
			}
		}
		
		if ($favorite > 0)
		{
			$GLOBALS["ext_id"] = $favorite;
			$ret = dlookup("name","smart_extranet","id = " . $favorite);
		}
		else
		{
			$GLOBALS["ext_id"] = $results_extranet[0];
			$ret = dlookup("name","smart_extranet","id = " .$results_extranet[0]);
		}

		return giveurl($ret,"index","");
		
	}
	
	function delete_extranet($del_ext_id)
	{
		$del_ext_name = dlookup("name","smart_extranet","id=".$del_ext_id);
		
		#delete all files
		$query_sel_files = "SELECT id FROM smart_document
								WHERE is_directory = '0'  AND extranet_id=" . $del_ext_id;
		$result_file = mysql_query($query_sel_files);
		while ($row_file = mysql_fetch_array($result_file)){
			delete_file($row_file["id"],$del_ext_id);
		}

		#delete all directories
		$query_del_dirs = "DELETE FROM smart_document
								WHERE is_directory = '1'  AND extranet_id=" . $del_ext_id;
		mysql_query($query_del_dirs);
		
		#delete all user accesses
		$query_del_access = "DELETE FROM smart_user_accesses
								WHERE extranet_id=" . $del_ext_id;
		mysql_query($query_del_access);
		
		#delete ghosts
		$query_ghosts = "SELECT smart_user.id, COUNT(smart_user_accesses.user_id) AS access_nr
							FROM smart_user
							LEFT JOIN smart_user_accesses
							ON smart_user.id = smart_user_accesses.user_id
							WHERE smart_user.rights<>'super_admin'
							GROUP BY smart_user.id
							HAVING access_nr=0";
		$result_ghosts = mysql_query($query_ghosts);
		while ($row_ghosts = mysql_fetch_array($result_ghosts)){
			$query_delete_user = "DELETE FROM smart_user
							WHERE id=" . $row_ghosts["id"];
			mysql_query($query_delete_user);
		};
		
		#delete extranet directory from incoming folder 
		remove_dir_all($GLOBALS['WWW_SECURITY']."incoming/" . $del_ext_name);
		
		#delete extranet directory from storage folder
		remove_dir_all($GLOBALS['WWW_SECURITY']."storage/" . $del_ext_id);
		
		#delete extranet
		$query_delete_ext = "DELETE FROM smart_extranet
								WHERE id=" . $del_ext_id;
		mysql_query($query_delete_ext);
		
		#delete extranet log
		$query_delete_ext = "DELETE FROM smart_log
								WHERE extranet_id=" . $del_ext_id;
		mysql_query($query_delete_ext);
	}
	
	function export_csv()
	{
				
		$query = "SELECT id, date_request, status, company, title, fname, lname, tel, email, f1, f2, www, extranet from smart_request";
		$results_request = mysql_query($query);
		
		$line = "\"ID\";\"Date\";\"Status\";\"Company\";\"Title\";\"First Name\";\"Last Name\";\"Tel\";\"Email\";\"Field 1\";\"Field 2\";\"Url\";\"Extranet\";\"Nb Doc\"\n";
		
		while ($row_request = mysql_fetch_array($results_request)){	
			if ($row_request['status'] == 'exist')
			{
				$extranet = dlookup("name","smart_extranet","id = ".$row_request['extranet']);
				$nb_doc = dlookup("count(*)","smart_document","is_directory = '0' and extranet_id = ".$row_request['extranet']);
			}
			else
			{
				$extranet = "";
				$nb_doc = 0;
			}
			$line .= $row_request['id'].";\"".$row_request['date_request']."\";\"".$row_request['status']."\";\"".$row_request['company']."\";\"".$row_request['title']."\";\"".$row_request['fname']."\";\"".$row_request['lname']."\";\"".$row_request['tel']."\";\"".$row_request['email']."\";\"".$row_request['f1']."\";\"".$row_request['f2']."\";\"".$row_request['www']."\";\"".$extranet."\";\"".$nb_doc."\"\n";
		
		}		
		if(is_file('export.csv'))
		{
			unlink('export.csv');
		}
		$file_ = fopen('export.csv', 'a+');
		fseek($file_, 0);
		fputs($file_,$line); 
		fclose($file_);

		// Dmarre la procdure de tlchargement
		
		$taille = filesize('export.csv');
		header("Pragma: public");
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Cache-Control: public");
		header("Content-Description: File Transfer");
		header("Content-Type: application/csv");
		header("Content-Disposition: attachment; filename=export.csv;");
		header("Content-Transfer-Encoding: binary");
		header("Content-Length: ".$taille);
		@readfile('export.csv');
		// Supprime le fichier temporaire du serveur
		unlink('export.csv');		
		
		
	}
 
	function extranet_capacity($extranet_id)
	{
		$max = $GLOBALS["ANIM_FLASH_6"];
		if($max > 0)
		{
			if ($GLOBALS["T_V"] == true)
			{
				$nb_user = dlookup("COUNT(*)","smart_user LEFT JOIN smart_user_accesses ON smart_user_accesses.user_id=smart_user.id","smart_user_accesses.extranet_id=" . $extranet_id);
			}
			else
			{
				$nb_user = dlookup("COUNT(*)","smart_user LEFT JOIN smart_user_accesses ON smart_user_accesses.user_id=smart_user.id","smart_user_accesses.extranet_id=" . $extranet_id . " OR smart_user.rights='super_admin'");
			}
			if ($nb_user < $max)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			return true;
		}
	}
	
	function code_unik($table, $nb)
	{
		$possible = "0123456789bcdfghjkmnpqrstvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"; 
		$code = "";
		$length = $nb;
		$i = 0; 
		while ($i < $length){ 
			  $char = substr($possible, mt_rand(0, strlen($possible)-1), 1);
			  $code .= $char;
			  $i++;
		}
		if(dlookup("count(*)","smart_".$table,"unik = '".$code."'") > 0)
		{
			return code_unik($table, $nb);
		}
		else
		{
			return $code;
		}
	}

	function folder_in_www()
	{
		$possible = "0123456789abcdfghjkmnpqrstvwxyz"; 
		$code = "";
		$length = 8;
		$i = 0; 
		while ($i < $length){ 
			  $char = substr($possible, mt_rand(0, strlen($possible)-1), 1);
			  $code .= $char;
			  $i++;
		}
		return $code;
	}
	
	function link_licence($x)
	{
		return strlen($x);
	}
	
	function link_exec_licence($all)
	{
		if($GLOBALS["SSL"] == false)
		{
			$delta = 8;
		}
		else
		{
			$delta = 9;
		}
		if((strlen($GLOBALS["SITE_ROOT"]) - $delta) != $all)
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	function populate_db($sqlfile) 
	{
		$mqr = @get_magic_quotes_runtime();
		@set_magic_quotes_runtime(0);
		$query = fread( fopen($sqlfile, 'r' ), filesize( $sqlfile ) );
		@set_magic_quotes_runtime($mqr);
		$pieces  = split_sql($query);

		for ($i=0; $i<count($pieces); $i++) {
			$pieces[$i] = trim($pieces[$i]);
			if(!empty($pieces[$i]) && substr($pieces[$i],0,1) != "#") {
				//echo "<p>".$pieces[$i]."</p>";
				
				$ret = mysql_query($pieces[$i]);
				if (!$ret) {
					echo "Error";
				}
			}
		}
	}

	function split_sql($sql) 
	{
		$sql = trim($sql);
		$sql = ereg_replace("\n#[^\n]*\n", "\n", $sql);

		$buffer = array();
		$ret = array();
		$in_string = false;

		for($i=0; $i<strlen($sql)-1; $i++) {
			if($sql[$i] == ";" && !$in_string) {
				$ret[] = substr($sql, 0, $i);
				$sql = substr($sql, $i + 1);
				$i = 0;
			}

			if($in_string && ($sql[$i] == $in_string) && $buffer[1] != "\\") {
				$in_string = false;
			}
			elseif(!$in_string && ($sql[$i] == '"' || $sql[$i] == "'") && (!isset($buffer[0]) || $buffer[0] != "\\")) {
				$in_string = $sql[$i];
			}
			if(isset($buffer[1])) {
				$buffer[0] = $buffer[1];
			}
			$buffer[1] = $sql[$i];
		}

		if(!empty($sql)) {
			$ret[] = $sql;
		}
		return($ret);
	}

	function get_option($name) {
		$ret = dlookup("value","smart_option","name = '".$name."'");
		if ($name == "install_flag" && $ret == "")
		{
			return "0";
		}
		else
		{
			return $ret;
		}
	}

	function set_option($name,$value) {
		$sql = "update smart_option set value = '".$value."' WHERE name = '".$name."'";
		mysql_query($sql);
	}	
	
	function giveurl($extranet,$file,$qs,$path = '%NO_PATH%')
	{
		$SITE_ROOT = $GLOBALS['SITE_ROOT'];
		$url_rewrite = get_option("url_rewriting");
		
		$format = 'long';
		
		$ret = "";
		
		if($url_rewrite == "0")
		{
			#No Rewriting !
			if(strlen($qs) > 0)
			{
				$qs = "&".$qs;
			}
			if ($format == "long")
			{
				$ret = $SITE_ROOT.$file.".php?ext_name=".$extranet."&path=".$path.$qs;
			}
			else
			{
				$ret = $file.".php?ext_name=".$extranet."&path=".$path.$qs;
			}
			$ret = str_replace("&path=%NO_PATH%","",$ret);
		}
		else
		{
			#Rewriting !
			if(strlen($qs) > 0)
			{
				$qs = "?".$qs;
			}
			if ($format == "long")
			{
				$ret = $SITE_ROOT.$extranet."/".$path.$file.".php".$qs;
			}
			else
			{
				$ret = $extranet."/".$path.$file.".php".$qs;
			}
			
			$ret = str_replace("index.php","",$ret);
			$ret = str_replace("%NO_PATH%","",$ret);
		}
		
		return $ret;
	}
	
	function givedirecturl($extranet,$doc_id,$cu_d,$u_id,$time)
	{
		$url_rewrite = get_option("url_rewriting");
		
		$ret = "";
		
		if($url_rewrite == "0")
		{
			#No Rewriting !
			$ret = "dl.php?ext_name=".$extranet."&f_id=".$doc_id."&cu_d=".$cu_d."&sender=".$u_id."&cu_u=$1&delta=".$time;
		}
		else
		{
			#Rewriting !
			$ret = "direct-".$extranet."-".$doc_id."-".$cu_d."-".$u_id."-$1-".$time;
		}
		
		return $ret;
	}
	
	function givedirecturlmobile($extranet,$doc_id,$cu_d,$u_id,$time)
	{		
		$ret = "";

			#No Rewriting !
		$ret = "dl.php?space=".$extranet."&f_id=".$doc_id."&cu_d=".$cu_d."&sender=".$u_id."&cu_u=$1&delta=".$time;

		return $ret;
	}
	
	function goto_www()
	{
		return "..".substr(dirname(realpath("index.php")),strrpos(dirname(realpath("index.php")),"/"));
	}	
	
	function profil_list()
	{
		#Liste profil
		$query_profil = "SELECT profil_id, profil_name FROM smart_profil ORDER BY profil_name";
		$results_profil = mysql_query($query_profil);
		$i = 0;
		while ($row_profil = mysql_fetch_array($results_profil)){
			$result_profil[$i] = $row_profil;
			$result_profil[$i]['profil_name_decode'] = utf8_encode($row_profil['profil_name']);
			$i++;
		}
		return $result_profil;
	}
	
	function simple_user_profil_list_dir($profil_id,$ext_id)
	{
		$list_dir = array();
		/* if(get_option("activate_profil") == 1)
		{
			$query = "SELECT parent_id FROM smart_document LEFT JOIN smart_document_profil ON smart_document.id = smart_document_profil.doc_id WHERE is_directory='0' AND extranet_id=" . $ext_id . " AND (direction_only='0' OR (direction_only='1' AND profil_id = ".$profil_id."))";
			$results_doc = mysql_query($query);
			while ($row_doc = mysql_fetch_array($results_doc)){
				if(!in_array($row_doc['parent_id'],$list_dir))
				{
					$list_dir[] = $row_doc['parent_id'];
					$parent = $row_doc['parent_id'];
					while($parent != 0)
					{
						$parent = dlookup("parent_id","smart_document","id = ".$parent);
						if(!in_array($parent,$list_dir))
						{
							$list_dir[] = $parent;
						}
					}
				}
			}
		}
		else
		{ */
			$query = "SELECT id FROM smart_document WHERE is_directory='1' AND extranet_id=" . $ext_id;
			$results_doc = mysql_query($query);
			while ($row_doc = mysql_fetch_array($results_doc)){
				if(!in_array($row_doc['id'],$list_dir))
				{
					$list_dir[] = $row_doc['id'];
				}
			}
		/* } */
		return $list_dir;
	}
	
	function nb_file_into_dir($profil_id,$dir_id)
	{
		$nb = 0;
		if(get_option("activate_profil") == 1)
		{
			if($_SESSION['rights'] == 'super_admin' OR $_SESSION['rights']=='limited_admin')
			{
				$query = "SELECT id, is_directory FROM smart_document WHERE parent_id = ".$dir_id;
			}
			else
			{
				$query = "SELECT id, is_directory FROM smart_document LEFT JOIN smart_document_profil ON smart_document.id = smart_document_profil.doc_id WHERE (direction_only='0' OR (direction_only='1' AND profil_id = ".$profil_id.")) AND parent_id = ".$dir_id;
			}
		}
		else
		{
			$query = "SELECT id, is_directory FROM smart_document WHERE parent_id = ".$dir_id;
		}
		$results_doc = mysql_query($query);
		while ($row_doc = mysql_fetch_array($results_doc)){
			if($row_doc['is_directory'] == '0')
			{
				$nb++;
			}
			else
			{
				$nb = $nb + nb_file_into_dir($profil_id,$row_doc['id']);
			}
		}
		return $nb;
	}
	
	function gps_from_exif($file)
	{
		//Lire les EXIF:
		$exif = exif_read_data($file,0,TRUE);
		if(isset($exif["GPS"]["GPSLatitude"]))
		{
			//Degrs:
			$latdeg=$exif["GPS"]["GPSLatitude"][0];
			$londeg=$exif["GPS"]["GPSLongitude"][0];

			//Minutes:
			$latmin=$exif["GPS"]["GPSLatitude"][1];
			$lonmin=$exif["GPS"]["GPSLongitude"][1];

			//Secondes:
			$latsec=$exif["GPS"]["GPSLatitude"][2];
			$lonsec=$exif["GPS"]["GPSLongitude"][2];

			//Hmisphre (N, S, W ou E):
			$lathem=$exif["GPS"]["GPSLatitudeRef"];
			$lonhem=$exif["GPS"]["GPSLongitudeRef"];

			//Altitude:
			$alt=$exif["GPS"]["GPSAltitude"][0];

			$deg_arr = explode("/",$latdeg);
			$deg_ = $deg_arr[0]/$deg_arr[1];
			$min_arr = explode("/",$latmin);
			$min_ = $min_arr[0]/$min_arr[1];
			$sec_arr = explode("/",$latsec);
			$sec_ = $sec_arr[0]/$sec_arr[1];
			
			$lat = $deg_ + ($min_ / 60) + ($sec_ / 3600);
			if($lathem == "S")
			{
				$lat = $lat * -1;
			}
			
			$deg_arr = explode("/",$londeg);
			$deg_ = $deg_arr[0]/$deg_arr[1];
			$min_arr = explode("/",$lonmin);
			$min_ = $min_arr[0]/$min_arr[1];
			$sec_arr = explode("/",$lonsec);
			$sec_ = $sec_arr[0]/$sec_arr[1];
			
			$lon = $deg_ + ($min_ / 60) + ($sec_ / 3600);
			if($lonhem == "W")
			{
				$lon = $lon * -1;
			}
			
				return $lat . "," . $lon;
			}
			else
			{
				return "";
			}
		}
		
	function maj_bdd_via_ftp($extranet_id,$ext_name, $parent_id,$indice,$niveau="")
	{
		
		//echo "<p>[".$indice."] check : ".$ext_name." pour parent_id =".$parent_id."<br />";
		$dir = $niveau.$GLOBALS["WWW_SECURITY"]."incoming/".$ext_name;
		//echo "DIR : ".$dir."<br />";
		if (is_dir($dir))
		{
			$dir_res = opendir($dir);
			$i = 0;
			while ($content = readdir($dir_res)) 
			{
		
					if ($content != "." && $content != ".." && is_dir($dir."/".$content)) 
					{
						$i++;
						 //echo $dir."/".$content." => ";
						//echo dlookup("count(*)","smart_document","extranet_id = ".$extranet_id." AND is_directory = '1' AND parent_id = ".$parent_id." AND name = '".$content."'");
						//echo "<br />"; 
						$id = dlookup("id","smart_document","extranet_id = ".$extranet_id." AND is_directory = '1' AND parent_id = ".$parent_id." AND name = '".$content."'");
						//echo "DLOOKUP : extranet_id = ".$extranet_id." AND is_directory = '1' AND parent_id = ".$parent_id." AND name = '".$content."'<br />";
						if($id > 0)
						{
							//echo "--existe</p>";
							$indice++;
							maj_bdd_via_ftp($extranet_id,$ext_name."/".$content, $id,$indice,$niveau);
							$indice--;
						}
						else
						{
							$sql = "INSERT INTO smart_document SET extranet_id = ".$extranet_id.",
																is_directory = '1',
																parent_id = ".$parent_id.",
																name = '".$content."',
																publish_time = '".date('Y-m-d H:i:s')."'";
							mysql_query($sql);
							//echo $sql."</p>";
							$id = mysql_insert_id();
							$indice++;
							maj_bdd_via_ftp($extranet_id,$ext_name."/".$content, $id,$indice,$niveau);
							$indice--;
						}

						

					}
			}
			closedir($dir_res);
			if($i == 0)
			{
			//echo "</p>";
			}	
		}
	}
	
	function donne_mdp($nb_car)
	{
		$new_pass = "";
        $possible = "0123456789";
		if(get_option("pwd_type") == 'an')
			{
				$possible .= "abcdfghjkmnpqrstvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"; 
			}
          
          $length=$nb_car;
          $i = 0; 
          while ($i < $length) 
            { 
              $char = substr($possible, mt_rand(0, strlen($possible)-1), 1);
              if (!strstr($new_pass, $char)) 
                { 
                   $new_pass .= $char;
                   $i++;
                }
            }
		return $new_pass;
	}
	
?>
