<?php
/*************************************************************************/
/* Smart Extranet  2004-2010. All right reserved.www.smart-extranet.com */
/*************************************************************************/

//ini_set('error_reporting', E_ALL);
ini_set('error_reporting', E_COMPILE_ERROR|E_ERROR|E_CORE_ERROR);

session_start();

#smarty
require '_php/smarty/libs/Smarty.class.php';

#realpath of www directory
$www_path = str_replace("\\", '/', realpath("../"));

#smarty settings
$smarty = new Smarty;

$smarty->compile_check = true;
$smarty->debugging = false;

$smarty->compile_dir = "_cache/";
$smarty->template_dir = "_templates/";

include("_config/config.inc.php");
include("_config/obconfig.inc.php");
include("_config/trialconfig.inc.php");
include("_include/functions.inc.php");
include("_lang/lang.inc.php");
include("_include/connect.inc.php");

$SMARTY_PATH = calculate_smarty_path();
$smarty->assign('PATH', $SMARTY_PATH);

#path
$path = "";
$parent_id = 0;

#assign path
$smarty->assign('php_path', $path);

#query_install

$query_install = "CREATE TABLE `smart_request` (
				  `id` int(4) NOT NULL auto_increment,
				  `company` varchar(50) default NULL,
				  `title` varchar(9) NOT NULL,
				  `fname` varchar(80) NOT NULL,
				  `lname` varchar(80) NOT NULL,
				  `email` varchar(90) NOT NULL,
				  `tel` varchar(15) default NULL,
				  `www` varchar(150) default NULL,
				  `f1` varchar(100) default NULL,
				  `f2` varchar(100) default NULL,
				  `ip` varchar(15) NOT NULL,
				  `status` enum('exist','waiting','new') NOT NULL,
				  `extranet` int(4) default NULL,
				  `date_request` datetime NOT NULL,
				  PRIMARY KEY  (`id`)
				) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=latin1;";

				
if ($NB_INSTALL == 2)
{				
				
				
#Conditionnal Display
if (strlen($TRIAL_MANAGEMENT_CODE) > 0)
	{
		$smarty->assign('code_init', true);
	}
	else
	{
		$smarty->assign('code_init', false);
	}

	function set_ini_file($dossier,$fichier,$variable,$value)
	{
		chmod($dossier, 0777);
		$inifile = $dossier.'/'.$fichier;
		set_infile ( $inifile , $variable, $value,";" );
		chmod($dossier, 0755);
	}


$page = htmlspecialchars(isset($_GET["page"])?$_GET["page"]:'list');

	if ($page == "logout")
		{
			$_SESSION['tial_management_pass'] = false;
		}

	#valiation login Form
	if(isset($_POST['ok']))
		{

			$code = htmlspecialchars(isset($_POST["trial_code"])?$_POST["trial_code"]:'');
			
			if ($code == $TRIAL_MANAGEMENT_CODE)
			{
				$_SESSION['tial_management_pass'] = true;
				$page = "list";
			}
			else
			{
				$error = $_0100549_code_mgt_invalid;
			}
		}

	#Validation settings Form
	if(isset($_POST['submit_settings']))
		{
			$TRIAL_MANAGEMENT_CODE = htmlspecialchars(isset($_POST["trial_code"])?$_POST["trial_code"]:'');
			$TRIAL_ACCESS_USER = htmlspecialchars(isset($_POST["opt_access"])?$_POST["opt_access"]:'');
			$TRIAL_USER_MESSAGE = stripslashes(htmlspecialchars(isset($_POST["txt_mess_user"])?$_POST["txt_mess_user"]:''));
			$TRIAL_FIELD1_LABEL = stripslashes(htmlspecialchars(isset($_POST["txt_label_field1"])?$_POST["txt_label_field1"]:''));
			$TRIAL_FIELD1_VALUES = stripslashes(htmlspecialchars(isset($_POST["txt_value_field1"])?$_POST["txt_value_field1"]:''));
			$TRIAL_FIELD2_LABEL = stripslashes(htmlspecialchars(isset($_POST["txt_label_field2"])?$_POST["txt_label_field2"]:''));
			$TRIAL_FIELD2_VALUES = stripslashes(htmlspecialchars(isset($_POST["txt_value_field2"])?$_POST["txt_value_field2"]:''));
			//$TRIAL_FORM_INTRODUCTION = stripslashes(htmlspecialchars(isset($_POST["txt_form_intro"])?$_POST["txt_form_intro"]:''));
			$TRIAL_BACKLINK = htmlspecialchars(isset($_POST["txt_backlink"])?$_POST["txt_backlink"]:'');
			$TRIAL_MANAGEMENT_EMAIL = htmlspecialchars(isset($_POST["txt_email"])?$_POST["txt_email"]:'');
			$SUBJECT = htmlspecialchars(isset($_POST["txt_email_subject"])?$_POST["txt_email_subject"]:'');
			$BODY = htmlspecialchars(isset($_POST["txt_email_body"])?$_POST["txt_email_body"]:'');
			$COND_USE = htmlspecialchars(isset($_POST["txt_cond_use"])?$_POST["txt_cond_use"]:'');
			$TRIAL_TITLE_REQUEST = htmlspecialchars(isset($_POST["txt_title_request"])?$_POST["txt_title_request"]:'');
			$TRIAL_TITLE_HOME = htmlspecialchars(isset($_POST["txt_title_home"])?$_POST["txt_title_home"]:'');
			$SERVICE_OVERVIEW = isset($_POST["txt_service_overview"])?$_POST["txt_service_overview"]:'';
			
			$nb_error = 0;
			$error = '';
			
			if (strlen($TRIAL_MANAGEMENT_CODE) == 0)
				{
					$nb_error++;
					$error .= $_0100580_forgot_pwd."<br />";
				}	
			if (strlen($TRIAL_MANAGEMENT_EMAIL) == 0 OR validate_email($TRIAL_MANAGEMENT_EMAIL) == false)
				{
					$nb_error++;
					$error .= $_0100581_email_err."<br />";
				}	
			if (strlen($SUBJECT) == 0)
				{
					$nb_error++;
					$error .= $_0100582_err_email_title."<br />";
				}	
			if (strlen($BODY) == 0)
				{
					$nb_error++;
					$error .= $_0100583_err_email_body."<br />";
				}	
			if (strlen($TRIAL_TITLE_REQUEST) == 0)
				{
					$nb_error++;
					$error .= $_0100742_err_title."<br />";
				}	
			
			if ($nb_error == 0)
				{
					#Service Overview
					chmod("_assets", 0777);
					unlink('_assets/service_overview.txt');
					$file_ = fopen('_assets/service_overview.txt', 'a+');
					fseek($file_, 0);
				    fputs($file_,stripslashes($SERVICE_OVERVIEW)); 
				    fclose($file_);
					chmod("_assets", 0755);
					
					#Cond use
					chmod("_assets/licence", 0777);
					unlink('_assets/licence/service_terms_use.txt');
					$file_ = fopen('_assets/licence/service_terms_use.txt', 'a+');
					fseek($file_, 0);
				    fputs($file_,stripslashes($COND_USE)); 
				    fclose($file_);
					chmod("_assets/licence", 0755);

				
					#Config 
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_MANAGEMENT_CODE',"\"".$TRIAL_MANAGEMENT_CODE."\"");
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_ACCESS_USER',"\"".$TRIAL_ACCESS_USER."\"");
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_USER_MESSAGE',"\"".str_replace("\n","",str_replace("\r","",$TRIAL_USER_MESSAGE))."\"");
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_FIELD1_LABEL',"\"".$TRIAL_FIELD1_LABEL."\"");
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_FIELD1_VALUES',"\"".str_replace("\n","",str_replace("\r","",$TRIAL_FIELD1_VALUES))."\"");
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_FIELD2_LABEL',"\"".$TRIAL_FIELD2_LABEL."\"");
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_FIELD2_VALUES',"\"".str_replace("\n","",str_replace("\r","",$TRIAL_FIELD2_VALUES))."\"");
					//set_ini_file("v","trialconfig.inc.php",'$TRIAL_FORM_INTRODUCTION',"\"".str_replace("\n","",str_replace("\r","",$TRIAL_FORM_INTRODUCTION))."\"");
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_BACKLINK',"\"".$TRIAL_BACKLINK."\"");
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_MANAGEMENT_EMAIL',"\"".$TRIAL_MANAGEMENT_EMAIL."\"");
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_TITLE_REQUEST',"\"".$TRIAL_TITLE_REQUEST."\"");
					set_ini_file("_config","trialconfig.inc.php",'$TRIAL_TITLE_HOME',"\"".$TRIAL_TITLE_HOME."\"");
					
					#email template
					$email = "[SUBJECT]\n";
					$email .= stripslashes($SUBJECT)."\n";
					$email .= "[/SUBJECT]\n";
					$email .= "[BODY]\n";
					$email .= stripslashes($BODY)."\n";
					$email .= "[/BODY]\n";
					chmod("_assets/email_templates", 0777);
					unlink('_assets/email_templates/'.$LANGUAGE_ID."/trial_link.txt");
					$file_ = fopen('_assets/email_templates/'.$LANGUAGE_ID."/trial_link.txt", 'a+');
					fseek($file_, 0);
				    fputs($file_,$email); 
				    fclose($file_);
					chmod("_assets/email_templates", 0755);
					$page = "success";
				}

				
		}		
	

	#Display
	if ($TRIAL_MANAGEMENT_CODE == '')
		{
			$display = "settings";
			mysql_query($query_install);
			if ($TRIAL_MANAGEMENT_EMAIL == '')
			{
				$TRIAL_MANAGEMENT_EMAIL = $POSTMASTER_EMAIL;
			}
		}
		else
		{
			$display = "login";
			$smarty->assign('login', false);		
			$smarty->assign('title_ban', $_0100547_trial_mgt);
			$query_maj = "UPDATE smart_request SET status = 'exist' WHERE extranet > 0";
			mysql_query($query_maj);
		}
		
	if ($_SESSION['tial_management_pass'] == true)	
		{
			$display = $page;
			$smarty->assign('login', true);		
		}
	
	#Display Settings
	if ($display == "settings")
		{
			$smarty->assign('title_ban', $_0100550_trial_set);
			$smarty->assign('TRIAL_MANAGEMENT_CODE', $TRIAL_MANAGEMENT_CODE);
			$smarty->assign('TRIAL_ACCESS_USER', $TRIAL_ACCESS_USER);
			$smarty->assign('TRIAL_USER_MESSAGE', str_replace("<br />","",$TRIAL_USER_MESSAGE));
			$smarty->assign('TRIAL_FIELD1_LABEL', $TRIAL_FIELD1_LABEL);
			$smarty->assign('TRIAL_FIELD1_VALUES', $TRIAL_FIELD1_VALUES);
			$smarty->assign('TRIAL_FIELD2_LABEL', $TRIAL_FIELD2_LABEL);
			$smarty->assign('TRIAL_FIELD2_VALUES', $TRIAL_FIELD2_VALUES);
			//$smarty->assign('TRIAL_FORM_INTRODUCTION', str_replace("<br />","",$TRIAL_FORM_INTRODUCTION));
			$smarty->assign('TRIAL_BACKLINK', $TRIAL_BACKLINK);
			$smarty->assign('TRIAL_MANAGEMENT_EMAIL', $TRIAL_MANAGEMENT_EMAIL);	
			$smarty->assign('TRIAL_TITLE_REQUEST', $TRIAL_TITLE_REQUEST);	
			$smarty->assign('TRIAL_TITLE_HOME', $TRIAL_TITLE_HOME);	
			
			
			$smarty->assign('SITE_ROOT', $SITE_ROOT);	

			$content = "";
			$fd=fopen("_assets/email_templates/".$LANGUAGE_ID."/trial_link.txt" ,"r");
			$body_email = "";
			$subject = false;
			$body = false;

			while(!feof($fd)){
				$line = fgets($fd,4096);

				if (strpos($line,"[/SUBJECT]") !== false) {
					$subject = false;
				}
				if (strpos($line,"[/BODY]") !== false) {
					$body = false;
				}
				if ($subject == true) {
					$subject_email = $line;
				}
				if ($body == true) {
					$body_email .= $line;
				}
				if (strpos($line,"[SUBJECT]") !== false) {
					$subject = true;
				}
				if (strpos($line,"[BODY]") !== false) {
					$body = true;
				}
			}
			fclose($fd);
			
			$smarty->assign('SUBJECT',$subject_email);		
			$smarty->assign('BODY',$body_email);	

			#Service Overview
			$SERVICE_OVERVIEW = "";
			$fd=fopen("_assets/service_overview.txt","r");
			while(!feof($fd))
			{
				$linie=fgets($fd,4096);
				$SERVICE_OVERVIEW .= $linie;
			}
			fclose($fd);
			$smarty->assign('SERVICE_OVERVIEW',$SERVICE_OVERVIEW);	
			
			#Conditions Use
			$COND_USE = "";
			$fd=fopen("_assets/licence/service_terms_use.txt","r");
			while(!feof($fd))
			{
				$linie=fgets($fd,4096);
				$COND_USE .= $linie;
			}
			fclose($fd);
			$smarty->assign('COND_USE',$COND_USE);	
		}
	
	if ($display == "list")
		{
		
			/* Begin template email for mailto */
			$tags['PRODUCT_NAME'] = $PRODUCT_NAME;
			
			$file_template=fopen("_assets/email_templates/".$GLOBALS['LANGUAGE_ID']."/trial_link.txt","r");

			$subject = false;
			

			while(!feof($file_template)){
				$line = trim(fgets($file_template,4096));

				foreach ($tags as $key => $value) {
					$line = str_replace('[+'.$key.'+]', $value, $line);
				}

				if (strpos($line,"[/SUBJECT]") !== false) {
					$subject = false;
				}	
				if ($subject == true) {
					$subject_email = $line;
				}
				if (strpos($line,"[SUBJECT]") !== false) {
					$subject = true;
				}
			}
			fclose($file_template);		
		
			$smarty->assign('subject_email', $subject_email);
			/* End template email for mailto */
			
			
			$smarty->assign('title_ban', $_0100584_list_request);
			if(isset($_GET['del']))
			{
				$id = $_GET['del'];
				$status = dlookup("status","smart_request","id = ".$id);
				if ($status != 'exist')
					{
						$query = "DELETE FROM smart_request WHERE id = ".$id;
						mysql_query($query);
					}
					else
					{
						$extranet_id = dlookup("extranet","smart_request","id =".$id);
						delete_extranet($extranet_id);
						$query = "DELETE FROM smart_request WHERE id = ".$id;
						mysql_query($query);
					}
			}
			
			if(isset($_GET['csv']))
			{
				export_csv();
			}
			
			if(isset($_GET['pwd']))
			{
				if (dlookup("count(*)","smart_user","email = '". $_GET['pwd']."'") > 0)
				{
					$email = $_GET['pwd'];
					$ext = $_GET['ext'];
					$new_pass = donne_mdp(7);

					$query_update="UPDATE smart_user SET password = MD5('".$new_pass."') WHERE email='".$email."' ";
					$update=mysql_query($query_update);

					$to[0] = $email;

					$url = giveurl($ext,"index","");
					$ext_link = '<a href="' . $url . '">' . $ext . '</a>';
					$tags['extranet_link'] = $ext_link;
					$tags['extranet_link_mobile'] = $SITE_ROOT."mobile/?space=".$ext;
					$tags['login'] = $email;
					$tags['password'] = $new_pass;

					if($update)
					{
					  $send = send_email("forgot_pass",$to,$POSTMASTER_EMAIL,$POSTMASTER_NAME,false,$tags);
					  $smarty->assign('pwd', true);
					  $smarty->assign('pwd_email', $email);
					}
				}
			}
			
			if(isset($_GET['send']))
			{
				$id = $_GET['send'];
				$query = "SELECT date_request, company, www, fname, lname, tel, email, f1, f2, title, ip FROM smart_request WHERE id = ".$id;
				$result_ = mysql_query($query);
				$row = mysql_fetch_row($result_);
				$date_request = $row[0];
				$company = $row[1];
				$www = $row[2];
				$fname = $row[3];
				$lname = $row[4];
				$tel = $row[5];
				$email = $row[6];
				$f1 = $row[7];
				$f2 = $row[8];
				$title = $row[9];
				$ip = $row[10];

				$tags['SITE_ROOT'] = $SITE_ROOT;
				$tags['PRODUCT_NAME'] = $PRODUCT_NAME;
				$tags['get'] = "trial.php?email=".urlencode($email)."&licence=".urlencode(md5($SERIAL_NUMBER.$email));
				$tags['fname'] = $fname;
				$tags['lname'] = $lname;
				$tags['company'] = $company;
				$tags['IP'] = $ip;
				$tags['date_request'] = date('d/m/Y H:i', strtotime($date_request));
				$tags['title'] = $title;
				$tags['email'] = $email;
				$tags['tel'] = $tel;
				$tags['www'] = $www;
				$tags['f1'] = $f1;
				$tags['f2'] = $f2;
				
				$to[0] = $email;
				if (send_email("trial_link",$to,$TRIAL_MANAGEMENT_EMAIL,$COMPANY_NAME,false,$tags))
					{
						$query = "UPDATE smart_request SET status = 'waiting' WHERE id =".$id;
						mysql_query($query);
						$smarty->assign('pwd', true);
					    $smarty->assign('pwd_email', $email);
					}
			}
	
		
			#order by ?
			$orderby = htmlspecialchars(isset($_GET["orderby"])?$_GET["orderby"]:"date_request");
			$orderbytype = htmlspecialchars(isset($_GET["orderbytype"])?$_GET["orderbytype"]:"SORT_STRING");
			$order = htmlspecialchars(isset($_GET["order"])?$_GET["order"]:"SORT_DESC");
			
			#query
			$query_request = "SELECT id, date_request, company, www, fname, lname, tel, email, f1, f2, status, extranet FROM smart_request";
			$results_request = mysql_query($query_request);

			$stat_us['new'] = 1;
			$stat_us['waiting'] = 2;
			$stat_us['exist'] = 3;
			
			$i = 0;
			while ($row_request = mysql_fetch_array($results_request)){

				$result_request[$i] = $row_request;
				
				$result_request[$i]['name'] = $row_request['lname']." ".$row_request['fname'];
				
				$result_request[$i]['date'] = $row_request["date_request"];
				$result_request[$i]['date_request'] = date('d/m', strtotime($row_request["date_request"]));
				$result_request[$i]['date_request_more'] = date('d/m/Y H:i', strtotime($row_request["date_request"]));
				
				
				$s = $row_request['status'];
				$result_request[$i]['stat_us'] = $stat_us[$s];
				if ($s == 'exist')
					{
						$ext_id = $row_request['extranet'];
						$result_request[$i]['extranet_name'] = dlookup("name","smart_extranet","id =".$ext_id);
						$result_request[$i]['extranet_nb_user'] = dlookup("count(*)","smart_user_accesses","extranet_id = ".$ext_id);
						$result_request[$i]['extranet_nb_login'] = dlookup("count(*)","smart_log","action = 'login_success' and extranet_id = ".$ext_id);
						if (dlookup("count(*)","smart_log","action = 'login_success' and extranet_id = ".$ext_id) > 0) {
						$result_request[$i]['extranet_last_login'] = date('d/m/Y H:i', dlookup("time","smart_log","action = 'login_success' and extranet_id = ".$ext_id." ORDER BY time desc limit 0,1"));
						}
						else
						{
							$result_request[$i]['extranet_last_login'] = "";
						}
						$result_request[$i]['extranet_nb_docs'] = dlookup("count(*)","smart_document","is_directory = '0' and extranet_id = ".$ext_id);
						$total = dir_space($WWW_SECURITY.'storage/' . $ext_id)/1024;
						$disk_usage = number_format($total / 1024, 2, '.', ' ');
						$result_request[$i]['extranet_nb_mo'] = $disk_usage;
					}
				$i++;
			}
			if ($order == 'SORT_DESC')
			{
				$result_request = arrayColumnSort($orderby, SORT_DESC, $orderbytype, $result_request);
			}
			else
			{
				$result_request = arrayColumnSort($orderby, SORT_ASC, $orderbytype, $result_request);
			}
			
			$smarty->assign('orderby', $orderby);
			$smarty->assign('nb', $i);
			$smarty->assign('result_request', $result_request);
		}
		

		
$smarty->assign('error', $error);
$smarty->assign('page', $page);
$smarty->assign('display', $display);

$smarty->assign('title_page', $PRODUCT_NAME." - ".$_0100547_trial_mgt);

$smarty->assign('banner', "banner_trial_management.jpg");

$smarty->display('trial/header.tpl');
$smarty->display('trial/'.$display.'.tpl');
$smarty->display('trial/footer.tpl');

}
else
{
	$smarty->assign('label_error', $_0100140_error_pagetitle);
	$smarty->assign('message', $_0100409_noright_adress);
	$img_pad = get_option("img_pad");
	$back_img_pad = get_option("back_img_pad");
	$back_color_pad = get_option("back_color_pad");
	$superimposed_img_pad = get_option("superimposed_img_pad");
	$smarty->assign('img_pad', $img_pad);
	$smarty->assign('back_img_pad', $back_img_pad);
	$smarty->assign('back_color_pad', $back_color_pad);
	$smarty->assign('superimposed_img_pad', $superimposed_img_pad);
	$smarty->display('error.tpl');	
}

?>
